%%%% c4.m
clear all, clc, close all
global tol maxiter
tol = 1e-8;
maxiter = 30;
scrsz = get(groot,'ScreenSize');
%%%
set(0,'defaultaxesfontsize',12,'defaultaxeslinewidth',1.6,...
   'defaultlinelinewidth',1.6,'defaultpatchlinewidth',.7)
%%    figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
format shortg

% %%% punto fijo
%  [p, k, err, P] = fixpt (g, .48, tol, maxiter)
% %%% biseccion
% g5 = @(x) g(x)-x;
%  %%% biseccion
% [c5, err5, yc5] = bisect (g5, 0.1, 2, tol)
%  
% g1 = @(x) x.^2-3;
% [c, err, yc] = bisect (g1, -1, 2, tol)
%  f = @(x) 2./x;
%  z = linspace(1.3,1.5);
%     figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  plot(z,f(z),'r',z,z,'k--'),grid on
%   [p, k, err, P] = fixpt (f, 1.4, tol, maxiter)
% f1 = @(x) x.^2-2;
% [c, err, yc] = bisect (f1, 1, 2, tol)
% 
% %%%%%%%%%
%%%% metodo de Newton para aproximar sqrt(3)
% xold = 2; xnew = 1;
% while abs(xnew-xold) > tol
%     xold = xnew
%     xnew = xnew/2 + 3/(2*xnew)
% end
% 
% f =@(x) x - 2.^(-x);
% fp = @(x) 1 + log(2)*2.^(-x);
% %%%% biseccion
% [c, err, yc] = bisect (f, 0, 1, tol);
% %%%% Newton
% [p0, err, k, y] = newton (f, fp, .5, tol, tol, maxiter);
% %%%
%    g1 = @(x) 9*x.^4+18*x.^3+38*x.^2-57*x+14;
%    g1p = @(x) 36*x.^3+54*x.^2+76*x-57;
% [p0, err, k, y] = newton (g1, g1p, .5, tol, tol, maxiter);
% %%%
%   g2 = @(x) 6*exp(x)-2*x.^3-3*x.^2-6*x-6;
%   g2p = @(x) 6*exp(x)-6*x.^2-6*x-6;
% [p0, err, k, y] = newton (g2, g2p, .5, tol, tol, maxiter)
% %%%
%   g0 = @(x) x.^2-3;
%   g0p = @(x) 2*x;
% [p0, err, k, y] = newton (g0, g0p, .5, tol, tol, maxiter)
% % %%%
%  s = @(x) x.*exp(x)-exp(x)+1;
%  ds = @(x) x.*exp(x);
% [p0, err, k, y] = newton (s, ds, .5, tol, tol, maxiter)
% %%%
% 
%   s1 = @(x) 2*x.*(1-x.*x+x).*log(x)-x.*x+1;
%   ds1 = @(x) -2*x+2*(x.*log(x)).*(-2*x+1)+2*(1+log(x)).*(1-x.*x+x);
% [p0, err, k, y] = newton (s1, ds1, .5, tol, tol, maxiter)
% 
u = @(x) x.^2-2;
du = @(x) 2*x;
p0 = 22;
r = sqrt(2);
[p0, err, k, yu] = newtontabla (r, u, du, p0, tol, tol, maxiter)
% %%%[p0, err, k, y] = newton (f, df, p0, delta, epsilon, max1)
f = @(x) exp(x)-x-1;
df = @(x) exp(x)-1;
ddf = @(x) exp(x);
r = 0;
p0 = 32;
[p0, err, k, yf] = newtontabla (r, f, df, p0, tol, tol, maxiter)
%%%%%
%%%% Newton modificado
w = @(x) (exp(x)-x-1)./(exp(x)-1);
dw = @(x) 1-exp(x).*(exp(x)-x-1)/(exp(x)-1).^2;
[p0, err, k, yw] = newtontabla (r, w, dw, p0, tol, tol, maxiter)
%%%
